#!/bin/bash

aliyun_docker='registry.cn-hangzhou.aliyuncs.com/wt_jenkins/docker-tdlcloud'
local_docker='witcloud/tdlcloud'

cp ../build/libs/*.jar ./
typeset -l project

jarname=`find -name "*.jar"| awk -F \/ '{print $2}'`
version=$(find -name "*.jar"| awk -F \/ '{print $2}' | cut -d - -f 2)
project=$(find -name "*.jar"| awk -F \/ '{print $2}' | cut -d - -f 1)

echo $version
echo $project
echo $jarname

mv ${jarname} tdlcloud.jar

docker login --username=上海辉泰信息科技有限公司 -p Witium37774020 registry.cn-hangzhou.aliyuncs.com

docker build -t ${local_docker}:${version} . | tee log

ImageId=`cat log | grep "Successfully built" | awk '{print $3}'`

echo $ImageId
rm log
rm *.jar
cd ../build/libs/
rm *.jar

docker tag ${ImageId}  ${aliyun_docker}:${version}
docker tag ${ImageId}  ${aliyun_docker}:latest
docker push ${aliyun_docker}:${version}
docker push ${aliyun_docker}:latest

docker rmi ${local_docker}:${version}
docker rmi ${aliyun_docker}:${version}
docker rmi ${aliyun_docker}:latest
