package com.example.tdl.mapper;

import com.example.tdl.domain.vo.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface GatewayMapper {
    List<ResultGatewayVo> getAll(@Param("companyNo") String companyNo);

    String getBySN(@Param("SN") String SN,@Param("companyNo") String companyNo);

    int addGateway(Map<Object,Object> map);

    int updateGateway(UpdateGatewayVo updateGatewayVo);

    int delGateway(Map<Object,Object> map);

    ResultGatewayVo getBySNAndType(@Param("SN") String SN,@Param("type") String type);

    int getIdBySNAndType(@Param("SN") String SN,@Param("type") String type,@Param("companyNo") String companyNo);

    int deployGateway(Map<Object,Object> map);

    Integer updateState(GatewayState gatewayState);

    String getTransportationNo(@Param("SN") String SN,@Param("type") String type);

    String getWarehouseNo(@Param("SN") String SN,@Param("type") String type);

    List<GatewaySNVo> getUnusedGateway(@Param("SN") String SN,@Param("companyNo") String companyNo);

    int updateCompany(UpdateGatewayCompanyVo updateGatewayCompanyVo);

    List<GatewayOnLineVo> getByWarehouseNo(@Param("warehouseNo") String warehouseNo);

    List<TypeVo> getGatewayType(@Param("companyNo") String companyNo);

     Integer  getModeByGateway(@Param("SN") String SN,@Param("type") String type);

     AlarmNoVo  getByGateway(@Param("SN") String SN,@Param("type") String type);

}
