package com.example.tdl.service;

import com.example.tdl.domain.vo.*;
import com.example.tdl.entity.AlarmLog;
import com.example.tdl.mapper.AlarmLogMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AlarmLogService {

    @Autowired
    private AlarmLogMapper alarmLogMapper;

    public List<ResultAlarmLog> getAll(String companyNo){
        return alarmLogMapper.getAll(companyNo);
    }

    public List<AlarmLogVo> getAlarmLog(String time,String companyNo){
        return  alarmLogMapper.getAlarmLog(time,companyNo);
    }

    public int addAlarmLog(AlarmLog addAlarmLogVo){
        return alarmLogMapper.addAlarmLog(addAlarmLogVo);
    }

    public List<ResultAlarmLog> getByTransportationNo(String  transportationNo){
        return  alarmLogMapper.getByTransportationNo(transportationNo);
    }

    public Integer getCount(String time,String companyNo){
        return alarmLogMapper.getCount(time,companyNo);
    }

    public Integer getBumpCount(String time,String companyNo){
        return alarmLogMapper.getBumpCount(time,companyNo);
    }

    public Integer getAlarmCount(String companyNo){
        return alarmLogMapper.getAlarmCount(companyNo);
    }

    public List<HistogramData> getByCount(String time,String companyNo){
         return alarmLogMapper.getByCount(time,companyNo);
    }

    public List<HistogramData> getByCountForABB(String time,String companyNo){
         return alarmLogMapper.getByCountForABB(time,companyNo);
    }

    public Integer getByTime(String transportationNo,Long startTime,Long endTime){
            return alarmLogMapper.getByTime(transportationNo,startTime,endTime);
    }

    public List<ResultAlarmLogVo> getAlarm(AlarmTermVo alarmTermVo){
        return  alarmLogMapper.getAlarm(alarmTermVo);
    }

    public List<AlarmLogVo> getRealTimeAlarm(String companyNo){
        return  alarmLogMapper.getRealTimeAlarm(companyNo);
    }


    public List<HistoryData> getValue(String transportationNo,String TDLSN ,String  classify){
        return  alarmLogMapper.getValue(transportationNo,TDLSN,classify);
    }
}
