package com.example.tdl.service;


import com.example.tdl.domain.vo.*;
import com.example.tdl.mapper.AlarmMapper;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


@Service
public class AlarmService {
    @Autowired
    private AlarmMapper alarmMapper;

    public List<ResultAlarmVo> getAll(String companyNo){
        return alarmMapper.getAll(companyNo);
    }

    public List<ResultAlarmVo> getAllByAlarmType(String companyNo,String alarmType){
        return alarmMapper.getAllByAlarmType(companyNo,alarmType);
    }

    public int addAlarm(AddAlarmVo addAlarmVo){
        return alarmMapper.addAlarm(addAlarmVo);
    }

    public int updateAlarm(UpdateAlarmVo updateAlarmVo){
        return alarmMapper.updateAlarm(updateAlarmVo);
    }

    public int delAlarm(DelAlarmVo delAlarmVo){
        return alarmMapper.delAlarm(delAlarmVo);
    }

    public ResultAlarmVo getByType(String alarmType,String companyNo){
        return alarmMapper.getByType(alarmType,companyNo);
    }

    public ResultAlarmVo getAlarmByWarehouseNo(String warehouseNo,String SN, String TDLSN){
        return alarmMapper.getAlarmByWarehouseNo(warehouseNo,SN, TDLSN);
    }

}
