package com.example.tdl.service;

import com.example.tdl.domain.vo.*;
import com.example.tdl.entity.TDLDataOffset;
import com.example.tdl.mapper.TDLDeviceMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class TDLDeviceService {
    @Autowired
    private TDLDeviceMapper tdlDeviceMapper;

    public List<ResultTDLDeviceVo> getAll(String companyNo){
        return tdlDeviceMapper.getAll(companyNo);
    }

    public List<ResultTDLDeviceVo> getByTerm(TDLDeviceTermVo tdlDeviceTermVo){
        return tdlDeviceMapper.getByTerm(tdlDeviceTermVo);
    }

    public int addTDLDevice(AddTDLDeviceVo addTDLDeviceVo){
        return tdlDeviceMapper.addTDLDevice(addTDLDeviceVo);
    }

    public int updateTDLDevice(UpdateTDLDeviceVo updateTDLDeviceVo){
        return tdlDeviceMapper.updateTDLDevice(updateTDLDeviceVo);
    }

    public int delTDLDevice(String TDLSN){
        return tdlDeviceMapper.delTDLDevice(TDLSN);
    }

    public ResultTDLDeviceVo getByTDLSN(String TDLSN){
        return tdlDeviceMapper.getByTDLSN(TDLSN);
    }

    public List<String> getByGatewaySN(String SN,String type){
        return  tdlDeviceMapper.getByGatewaySN(SN,type);
    }

    public List<String> getTdlSN(String SN,String type){
        return  tdlDeviceMapper.getTdlSN(SN,type);
    }

    public String getTdl(String SN,String type){
        return  tdlDeviceMapper.getTdl(SN,type);
    }

    public List<TDLDeviceVo> getTdlByGatewaySN(String SN, String type) {
        return tdlDeviceMapper.getTdlByGatewaySN(SN, type);
    }

    public List<TdlSNVo> getUnusedTDL(String TDLSN,String companyNo){
        return tdlDeviceMapper.getUnusedTDL(TDLSN,companyNo);
    }


    public ResultTDLDeviceVo getByTransportationNo(String transportationNo){
        return tdlDeviceMapper.getByTransportationNo(transportationNo);
    }

    public int updateCompany(String TDLSN,String companyNo){
        return tdlDeviceMapper.updateCompany(TDLSN,companyNo);
    }

    public int updateTDLOffset(String TDLSN, String offset) {
        return tdlDeviceMapper.updateTDLOffset(TDLSN, offset);
    }
}
