package com.example.tdl.service;


import com.example.tdl.domain.vo.*;
import com.example.tdl.mapper.TDLLogMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class TDLLogService {

    @Autowired
    private TDLLogMapper tdlLogMapper;

    public ResultGatewayVo getByNo(String transportationNo){
        return  tdlLogMapper.getByNo(transportationNo);
    }

    public TDLLogVo getByTransportationNo(String transportationNo){
        return  tdlLogMapper.getByTransportationNo(transportationNo);
    }

    public List<String> getTdlSN(String transportationNo){
        return  tdlLogMapper.getTdlSN(transportationNo);
    }

    public String getSN(String transportationNo){
        return  tdlLogMapper.getSN(transportationNo);
    }


    public List<String> getByAlarm(DelAlarmVo delAlarmVo){
        return  tdlLogMapper.getByAlarm(delAlarmVo);
    }

    public ResultAlarmVo getByTdl(String transportationNo,String TdlSN){
        return  tdlLogMapper.getByTdl(transportationNo,TdlSN);
    }

    public ResultAlarmVo getWarehouseByTdl(String warehouseNo,String TdlSN){
        return  tdlLogMapper.getWarehouseByTdl(warehouseNo,TdlSN);
    }
    public ResultAlarmVo getAlarm(String gatewaySN,String gatewayType,String TdlSN){
        return  tdlLogMapper.getAlarm(gatewaySN,gatewayType,TdlSN);
    }

    public List<WarehouseLogVo> getByWarehouse(String warehouseNo){
        return  tdlLogMapper.getByWarehouse(warehouseNo);
    }

    public Long getTimeByWarehouseNo(String warehouseNo,String SN){
        return  tdlLogMapper.getTimeByWarehouseNo(warehouseNo,SN);
    }

    public List<ResultWarehouseNoAndTDLSNAndTimeVo> getByWarehouseNoAndTime(DownloadForWarehouseVo downloadForWarehouseVo){
        return tdlLogMapper.getByWarehouseNoAndTime(downloadForWarehouseVo);
    }

    public List<ResultWarehouseNoAndTDLSNAndTimeVo> getByWarehouseNo(String warehouseNo){
        return tdlLogMapper.getByWarehouseNo(warehouseNo);
    }
}
