package com.example.tdl.util;


import com.aliyun.oss.OSSClient;
import com.aliyun.oss.model.*;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.multipart.MultipartFile;

import java.io.*;
import java.net.URL;
import java.util.Date;

public class AliyunOSSClientUtil {
    private static Logger logger = LoggerFactory.getLogger(AliyunOSSClientUtil.class);

    //阿里云API的内或外网域名
    private static String ENDPOINT;

    //阿里云API的密钥Access Key ID
    private static String ACCESS_KEY_ID;

    //阿里云API的密钥Access Key Secret
    private static String ACCESS_KEY_SECRET;

    //阿里云API的bucket名称
    private static String BACKET_NAME;

    //阿里云API的文件夹名称
    private static String FOLDER1;

    private static String FOLDER2;

    private static String FOLDER3;

    private static String FOLDER4;

    private static String FOLDER5;

    private static String FOLDER6;

    private static String FOLDER7;

    private static CannedAccessControlList acl_pub_readwrite = CannedAccessControlList.PublicReadWrite;

    //初始化属性
    static {
        ENDPOINT = OSSClientConstants.ENDPOINT;
        ACCESS_KEY_ID = OSSClientConstants.ACCESS_KEY_ID;
        ACCESS_KEY_SECRET = OSSClientConstants.ACCESS_KEY_SECRET;
        BACKET_NAME = OSSClientConstants.BACKET_NAME;
        FOLDER1 = OSSClientConstants.FOLDER1;
        FOLDER2 = OSSClientConstants.FOLDER2;
        FOLDER3 = OSSClientConstants.FOLDER3;
        FOLDER4 = OSSClientConstants.FOLDER4;
        FOLDER5 = OSSClientConstants.FOLDER5;
        FOLDER6 = OSSClientConstants.FOLDER6;
        FOLDER7 = OSSClientConstants.FOLDER7;
    }

    public static String getENDPOINT() {
        return ENDPOINT;
    }

    public static void setENDPOINT(String ENDPOINT) {
        AliyunOSSClientUtil.ENDPOINT = ENDPOINT;
    }

    public static String getAccessKeyId() {
        return ACCESS_KEY_ID;
    }

    public static void setAccessKeyId(String accessKeyId) {
        ACCESS_KEY_ID = accessKeyId;
    }

    public static String getAccessKeySecret() {
        return ACCESS_KEY_SECRET;
    }

    public static void setAccessKeySecret(String accessKeySecret) {
        ACCESS_KEY_SECRET = accessKeySecret;
    }

    public static String getBacketName() {
        return BACKET_NAME;
    }

    public static void setBacketName(String backetName) {
        BACKET_NAME = backetName;
    }

    public static String getFOLDER1() {
        return FOLDER1;
    }

    public static void setFOLDER1(String FOLDER1) {
        AliyunOSSClientUtil.FOLDER1 = FOLDER1;
    }

    public static String getFOLDER2() {
        return FOLDER2;
    }

    public static void setFOLDER2(String FOLDER2) {
        AliyunOSSClientUtil.FOLDER2 = FOLDER2;
    }

    public static String getFOLDER3() {
        return FOLDER3;
    }

    public static void setFOLDER3(String FOLDER3) {
        AliyunOSSClientUtil.FOLDER3 = FOLDER3;
    }

    public static String getFOLDER4() {
        return FOLDER4;
    }

    public static void setFOLDER4(String FOLDER4) {
        AliyunOSSClientUtil.FOLDER4 = FOLDER4;
    }

    public static String getFOLDER5() {
        return FOLDER5;
    }

    public static void setFOLDER5(String FOLDER5) {
        AliyunOSSClientUtil.FOLDER5 = FOLDER5;
    }

    public static String getFOLDER6() {
        return FOLDER6;
    }

    public static void setFOLDER6(String FOLDER6) {
        AliyunOSSClientUtil.FOLDER6 = FOLDER6;
    }

    public static String getFOLDER7() {
        return FOLDER7;
    }

    public static void setFOLDER7(String FOLDER7) {
        AliyunOSSClientUtil.FOLDER7 = FOLDER7;
    }

    /**
     * 获取阿里云OSS客户端对象
     * @return ossClient
     */
    public static  OSSClient getOSSClient(){
        return new OSSClient(ENDPOINT,ACCESS_KEY_ID, ACCESS_KEY_SECRET);//ossEndpoint, aliyunId, aliyunSecret
    }

    /**
     * 创建存储空间
     * @param ossClient      OSS连接
     * @param bucketName 存储空间
     * @return
     */
    public  static void createBucketName(OSSClient ossClient,String bucketName){
        //存储空间
        final String bucketNames=bucketName;
        if(!ossClient.doesBucketExist(bucketName)){
            //创建存储空间
            ossClient.setBucketAcl(bucketName,CannedAccessControlList.PublicRead);
            logger.info("创建存储空间成功");
        }
    }

    /**
     * 删除存储空间buckName
     * @param ossClient  oss对象
     * @param bucketName  存储空间
     */
    public static  void deleteBucket(OSSClient ossClient, String bucketName){
        ossClient.deleteBucket(bucketName);
        logger.info("删除" + bucketName + "Bucket成功");
    }

    /**
     * 上传图片
     *
     * @param url
     */
    public static void uploadImg2Oss(OSSClient ossClient,String url) {
        File fileOnServer = new File(url);
        FileInputStream fin;
        try {
            fin = new FileInputStream(fileOnServer);
            String[] split = url.split("/");
            uploadFile2OSS(ossClient,fin, split[split.length - 1]);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
            logger.info("图片上传失败" +e.toString());
        }
    }

    public static String uploadImg2Oss(OSSClient ossClient, MultipartFile file, String number,String  imageType ) {

        String originalFilename = file.getOriginalFilename();
        String name = number + originalFilename.substring(originalFilename.lastIndexOf(".")).toLowerCase();
        try {
            InputStream inputStream = file.getInputStream();
            uploadFile2OSS(ossClient,inputStream, name,imageType);
            return name;
        } catch (Exception e) {
            logger.info("图片上传失败！");
            return null;
            //throw new ImgException("图片上传失败");
        }
    }

    /**
     * 获得图片路径
     *
     * @param fileUrl
     * @return
     */
    public static String getImgUrl(OSSClient ossClient,String fileUrl) {
        if (!StringUtils.isEmpty(fileUrl)) {
            String[] split = fileUrl.split("/");
            return getUrl(ossClient,FOLDER2 + split[split.length - 1]);
        }
        return null;
    }

    /**
     * 上传到OSS服务器  如果同名文件会覆盖服务器上的
     *
     * @param instream 文件流
     * @param fileName 文件名称 包括后缀名
     * @return 出错返回"" ,唯一MD5数字签名
     */
    public static String uploadFile2OSS(OSSClient ossClient,InputStream instream, String fileName) {
        String ret = "";
        try {
            //创建上传Object的Metadata
            ObjectMetadata objectMetadata = new ObjectMetadata();
            objectMetadata.setContentLength(instream.available());
            objectMetadata.setCacheControl("no-cache");
            objectMetadata.setContentType("image/jpeg");
            objectMetadata.setContentDisposition("inline;filename=" + fileName);
            //上传文件
            PutObjectResult putResult = ossClient.putObject(BACKET_NAME, FOLDER2 + fileName, instream, objectMetadata);
            ret = putResult.getETag();
        } catch (IOException e) {
            logger.error(e.getMessage(), e);
        } finally {
            try {
                if (instream != null) {
                    instream.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return ret;
    }

    public static String uploadFile2OSS(OSSClient ossClient,InputStream instream, String fileName,String  imageType ) {
        String ret = "";
        try {
            //创建上传Object的Metadata
            ObjectMetadata objectMetadata = new ObjectMetadata();
            objectMetadata.setContentLength(instream.available());
            objectMetadata.setCacheControl("no-cache");
            objectMetadata.setContentType("image/jpeg");
            objectMetadata.setContentDisposition("inline;filename=" + fileName);
            //上传文件
            String key = fileName;
            if("user".equals(imageType)){
                key = FOLDER1+key;
            }else if("company".equals(imageType)){
                key = FOLDER2+key;
            }else if("truck".equals(imageType)){
                key = FOLDER3+key;
            }else if ("warehouse".equals(imageType)){
                key = FOLDER5+key;
            }else if("circuit".equals(imageType)){
                key = FOLDER6+key;
            }else if("alarmLogABB".equals(imageType)){
                key = FOLDER7+key;
            }
            PutObjectResult putResult = ossClient.putObject(BACKET_NAME, key, instream, objectMetadata);
            ret = putResult.getETag();
        } catch (IOException e) {
            logger.error(e.getMessage(), e);
        } finally {
            try {
                if (instream != null) {
                    instream.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return ret;
    }

    /**
     * 创建模拟文件夹
     * @param ossClient oss连接
     * @param bucketName 存储空间
     * @param folder   模拟文件夹名如"qj_nanjing/"
     * @return  文件夹名
     */
    public  static String createFolder(OSSClient ossClient,String bucketName,String folder){
        //文件夹名
        final String keySuffixWithSlash =folder;
        //判断文件夹是否存在，不存在则创建
        if(!ossClient.doesObjectExist(bucketName, keySuffixWithSlash)){
            //创建文件夹
            ossClient.putObject(bucketName, keySuffixWithSlash, new ByteArrayInputStream(new byte[0]));
            logger.info("创建文件夹成功");
            //得到文件夹名
            OSSObject object = ossClient.getObject(bucketName, keySuffixWithSlash);
            String fileDir=object.getKey();
            return fileDir;
        }
        return keySuffixWithSlash;
    }

    /**
     * 获得url链接
     *
     * @param key
     * @return
     */
    public  static String getUrl(OSSClient ossClient,String key) {
        // 设置URL过期时间为10年  3600l* 1000*24*365*10
        Date expiration = new Date(new Date().getTime() + 3600l * 1000 * 24 * 365 * 10);
        // 生成URL
        URL url = ossClient.generatePresignedUrl(BACKET_NAME, key, expiration);
        if (url != null) {
            return url.toString();
        }
        return null;
    }

    /**
     * 根据key删除OSS服务器上的文件
     * @param ossClient  oss连接
     * @param bucketName  存储空间
     * @param folder  模拟文件夹名 如"qj_nanjing/"
     * @param key Bucket下的文件的路径名+文件名 如："upload/cake.jpg"
     */
    public static void deleteFile(OSSClient ossClient, String bucketName, String folder, String key){
        ossClient.deleteObject(bucketName, folder + key);
        logger.info("删除" + bucketName + "下的文件" + folder + key + "成功");
    }

    /**
     * 上传图片/文件至OSS
     * @param ossClient  oss连接
     * @param file 上传文件（文件全路径如：D:\\image\\cake.jpg）
     * @return String 返回的唯一MD5数字签名
     * */
    public static  String uploadObject2OSS(OSSClient ossClient, File file) {
        String resultStr = null;
        try {
            //以输入流的形式上传文件
            InputStream is = new FileInputStream(file);
            //文件名
            String fileName = file.getName();
            //文件大小
            Long fileSize = file.length();
            //创建上传Object的Metadata
            ObjectMetadata metadata = new ObjectMetadata();
            //上传的文件的长度
            metadata.setContentLength(is.available());
            //指定该Object被下载时的网页的缓存行为
            metadata.setCacheControl("no-cache");
            metadata.setContentType("application/octet-stream");
            //指定该Object下设置Header
            metadata.setHeader("Pragma", "no-cache");
            //指定该Object被下载时的内容编码格式
            metadata.setContentEncoding("utf-8");
            //文件的MIME，定义文件的类型及网页编码，决定浏览器将以什么形式、什么编码读取文件。如果用户没有指定则根据Key或文件名的扩展名生成，
            //如果没有扩展名则填默认值application/octet-stream
            metadata.setContentType(getContentType(fileName));
            //指定该Object被下载时的名称（指示MINME用户代理如何显示附加的文件，打开或下载，及文件名称）
            metadata.setContentDisposition("attachment;filename=" + fileName );
            //上传文件   (上传文件流的形式)
            PutObjectResult putResult = null;
            if(fileName.contains("时") && fileName.contains("分") && fileName.contains("秒")){
                putResult = ossClient.putObject(BACKET_NAME, FOLDER3+ fileName, is, metadata);
            } else if(fileName.contains("CHN")){
                putResult = ossClient.putObject(BACKET_NAME, FOLDER6+ fileName, is, metadata);
            } else if(fileName.contains("仓库温湿度观测记录") || fileName.contains("WarehouseData")||  fileName.contains("倉庫の温度および湿度の観測記録")){
                putResult = ossClient.putObject(BACKET_NAME, FOLDER5+ fileName, is, metadata);
            } else if(fileName.contains("报警日志数据")){
                putResult = ossClient.putObject(BACKET_NAME, FOLDER7+ fileName, is, metadata);
            } else {
                putResult = ossClient.putObject(BACKET_NAME, FOLDER1+ fileName, is, metadata);
            }
            //解析结果
            resultStr = putResult.getETag();
        } catch (Exception e) {
            e.printStackTrace();
            logger.error("上传阿里云OSS服务器异常." + e.getMessage(), e);
        }
        return resultStr;
    }

    /**
     * 通过文件名判断并获取OSS服务文件上传时文件的contentType
     * @param fileName 文件名
     * @return 文件的contentType
     */
    public static final String getContentType(String fileName){
        //文件后缀
        String fileExtension = fileName.substring(fileName.lastIndexOf("."));
        if("bmp".equalsIgnoreCase(fileExtension))
            return "image/bmp";
        if("gif".equalsIgnoreCase(fileExtension))
            return "image/gif";
        if("jpeg".equalsIgnoreCase(fileExtension) || "jpg".equalsIgnoreCase(fileExtension)  || "png".equalsIgnoreCase(fileExtension) )
            return "image/jpeg";
        if("html".equalsIgnoreCase(fileExtension))
            return "text/html";
        if("txt".equalsIgnoreCase(fileExtension))
            return "text/plain";
        if("vsd".equalsIgnoreCase(fileExtension))
            return "application/vnd.visio";
        if("ppt".equalsIgnoreCase(fileExtension) || "pptx".equalsIgnoreCase(fileExtension))
            return "application/vnd.ms-powerpoint";
        if("doc".equalsIgnoreCase(fileExtension) || "docx".equalsIgnoreCase(fileExtension))
            return "application/msword";
        if("xml".equalsIgnoreCase(fileExtension))
            return "text/xml";
        return "text/html";
    }



    //测试
    public static void main(String[] args) {
        //初始化OSSClient
        OSSClient ossClient=AliyunOSSClientUtil.getOSSClient();
        //上传文件
        String files="E://仓库温湿度观测记录-1529909289444.zip";
        File filess=new File(files);
        String md5key = AliyunOSSClientUtil.uploadObject2OSS(ossClient, filess);
        logger.info("上传后的文件MD5数字唯一签名:" + md5key);
    }

}
