package com.example.tdl.util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CSVUtils {

    private static final Logger log = LoggerFactory.getLogger(CSVUtils.class);


    public static File createCSVFile(List<Object> head, List<List<Object>> dataList,String outPutPath, String filename) {
        File csvFile = null;
        BufferedWriter csvWtriter = null;
        try {
            csvFile = new File(outPutPath + File.separator + filename + ".csv");
            File parent = csvFile.getParentFile();
            if (parent != null && !parent.exists()){
                parent.mkdirs();
            }
            csvFile.createNewFile();
            FileOutputStream fos = new FileOutputStream(csvFile);
            // 写入bom头
            byte[] uft8bom={(byte)0xef,(byte)0xbb,(byte)0xbf};
            //String bOM = new String(new byte[] { (byte) 0xEF, (byte) 0xBB, (byte) 0xBF });
            fos.write(uft8bom);
            // GB2312使正确读取分隔符","
            csvWtriter = new BufferedWriter(new OutputStreamWriter(fos, "UTF-8"));
            // 写入文件头部
            writeRow(head, csvWtriter);

            // 写入文件内容
            for (List<Object> row : dataList) {
                writeRow(row, csvWtriter);
            }
            csvWtriter.flush();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                csvWtriter.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return csvFile;
    }

   /* *
     * 写一行数据方法
     * @param row
     * @param csvWriter
     * @throws IOException*/

    private static void writeRow(List<Object> row, BufferedWriter csvWriter) throws IOException {
        // 写入文件头部
        for (Object data : row) {
            StringBuffer sb = new StringBuffer();
            String rowStr = sb.append("\"").append(data).append("\",").toString();
            csvWriter.write(rowStr);
        }
        csvWriter.newLine();
    }


    /**
     * 测试数据
     *
     * @param args
     */
    @SuppressWarnings({ "rawtypes", "unchecked" })
    public static void main(String[] args) {
        List<Object> head = new ArrayList<Object>(){{
            add("时间");
            add("最大值");
            add("最小值");
            add("平均值");
        }};
        List<List<Object>> dataList = new ArrayList<>();
        createCSVFile(head,dataList,"E:/","小时粗糙度");
    }





}
