package com.example.tdl.util;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.google.gson.JsonSyntaxException;

public class JsonUtils {

    public static JsonElement getJsonElement(String jsonString) {
        JsonElement jsonElement;
        try {
            jsonElement = new JsonParser().parse(jsonString);
        } catch (JsonSyntaxException ex) {
            return null;
        }
        return jsonElement;
    }

    public static JsonObject getJsonObject(String jsonString) {
        JsonElement jsonElement = getJsonElement(jsonString);
        try {
            return jsonElement != null ? jsonElement.getAsJsonObject() : null;
        } catch (IllegalStateException e) {
            return null;
        }
    }

    public static boolean isJson(String jsonString) {
        JsonElement jsonElement = getJsonElement(jsonString);
        return jsonElement != null;
    }

    public static boolean isJsonObject(String jsonString) {
        JsonElement jsonElement = getJsonElement(jsonString);
        if (jsonElement == null) {
            return false;
        } else {
            return jsonElement.isJsonObject();
        }
    }

    public static boolean isJsonArray(String jsonString) {
        JsonElement jsonElement = getJsonElement(jsonString);
        if (jsonElement == null) {
            return false;
        } else {
            return jsonElement.isJsonArray();
        }
    }

    public static JsonObject changeJsonKey(JsonObject jsonObject, String oldKey, String newKey) {
        if (jsonObject.has(oldKey)) {
            JsonElement value = jsonObject.get(oldKey);
            jsonObject.remove(oldKey);
            jsonObject.add(newKey, value);
        }
        return jsonObject;
    }
}
