package com.example.tdl.util;


import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.*;
import javax.mail.internet.MimeMessage.RecipientType;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Properties;

public class MailUtil {

	//发件人地址
	public static String senderAddress = "postmaster@witium.com";
	//发件人账户名
	public static String senderAccount = "postmaster@witium.com";
	//发件人账户密码
	public static String senderPassword = "dJZU4LXZtpRc1Ybz";

	public static void sendMail(List<String> toAddressStr, String subject, String text) throws Exception{

		//设置发送邮件需要的属性
		Properties props = new Properties();
		//主机地址
		props.put("mail.smtp.host", "smtp.qiye.163.com");
		//是否打开验证:必须打开
		props.put("mail.smtp.auth", "true");

		props.put("mail.smtp.socketFactory.class","javax.net.ssl.SSLSocketFactory");
		props.setProperty("mail.smtp.socketFactory.fallback","false");
		props.setProperty("mail.smtp.port","465");
		props.setProperty("mail.smtp.socketFactory.port","465");

		//取的与邮件服务器连接
		Session session = Session.getDefaultInstance(props);
		//创建一封邮件
		MimeMessage mimeMessage = new MimeMessage(session);
		//设置发送地址
		InternetAddress fromAddress = new InternetAddress(senderAddress);
		mimeMessage.setFrom(fromAddress);
		//设置接收地址(多个)
		InternetAddress[] address = new InternetAddress[toAddressStr.size()];
		for(int i = 0;i<toAddressStr.size();i++){
			address[i] = new InternetAddress(toAddressStr.get(i)) ;
		}
		//第一个参数：to,发送 ; cc,抄送 ; bcc,暗送
		//第二个参数：接收者的地址
		mimeMessage.setRecipients(RecipientType.TO, address);
		//设置标题
		mimeMessage.setSubject(subject, "UTF-8");
		//设置正文
		mimeMessage.setContent(text,"text/html;charset=utf-8");

		//发送:坐火箭
		Transport transport = session.getTransport("smtp");

		transport.connect(senderAccount, senderPassword);
		//第一个参数：邮件
		//第二个参数：接收地址
		transport.sendMessage(mimeMessage, mimeMessage.getAllRecipients());

		//关闭
		transport.close();
		System.out.println("ok");
	}


	public static void sendAttachment(List<String> toAddressStr, String subject, String text,String  html) throws Exception {
		Properties props = new Properties();
		//设置用户的认证方式
		props.setProperty("mail.smtp.auth", "true");
		//设置传输协议
		props.setProperty("mail.transport.protocol", "smtp");
		//设置发件人的SMTP服务器地址
		props.setProperty("mail.smtp.host", "smtp.163.com");
		//2、创建定义整个应用程序所需的环境信息的 Session 对象
		Session session = Session.getInstance(props);
		//设置调试信息在控制台打印出来
		session.setDebug(true);
		//3、创建邮件的实例对象
		Message msg = getMimeMessage(session,toAddressStr,subject,text,html);
		//4、根据session对象获取邮件传输对象Transport
		Transport transport = session.getTransport();
		//设置发件人的账户名和密码
		transport.connect(senderAccount, senderPassword);
		//发送邮件，并发送到所有收件人地址，message.getAllRecipients() 获取到的是在创建邮件对象时添加的所有收件人, 抄送人, 密送人
		transport.sendMessage(msg,msg.getAllRecipients());

		//5、关闭邮件连接
		transport.close();
	}

	public static MimeMessage getMimeMessage(Session session,List<String> toAddressStr, String subject, String addr,String html) throws Exception{
		//1.创建一封邮件的实例对象
		MimeMessage msg = new MimeMessage(session);
		//2.设置发件人地址
		msg.setFrom(new InternetAddress(senderAddress));
		/**
		 * 3.设置收件人地址（可以增加多个收件人、抄送、密送），即下面这一行代码书写多行
		 * MimeMessage.RecipientType.TO:发送
		 * MimeMessage.RecipientType.CC：抄送
		 * MimeMessage.RecipientType.BCC：密送
		 */
		InternetAddress[] address = new InternetAddress[toAddressStr.size()];
		for(int i = 0;i<toAddressStr.size();i++){
			address[i] = new InternetAddress(toAddressStr.get(i)) ;
		}
		msg.setRecipients(RecipientType.TO, address);
		msg.setSubject(subject,"UTF-8");

		//下面是设置邮件正文
		//msg.setContent("简单的纯文本邮件！", "text/html;charset=UTF-8");

		// 5. 创建图片"节点"
		MimeBodyPart image = new MimeBodyPart();
		// 读取本地文件
		DataHandler dh = new DataHandler(new FileDataSource("src\\mailTestPic.png"));
		// 将图片数据添加到"节点"
		image.setDataHandler(dh);
		// 为"节点"设置一个唯一编号（在文本"节点"将引用该ID）
		image.setContentID("mailTestPic");

		// 6. 创建文本"节点"
		MimeBodyPart text = new MimeBodyPart();
		// 这里添加图片的方式是将整个图片包含到邮件内容中, 实际上也可以以 http 链接的形式添加网络图片


		text.setContent(html, "text/html;charset=UTF-8");


		// 9. 创建附件"节点"
		MimeBodyPart attachment = new MimeBodyPart();
		// 读取本地文件
		DataHandler dh2 = new DataHandler(new FileDataSource(addr));
		// 将附件数据添加到"节点"
		attachment.setDataHandler(dh2);
		// 设置附件的文件名（需要编码）
		attachment.setFileName(MimeUtility.encodeText(dh2.getName()));

		// 10. 设置（文本+图片）和 附件 的关系（合成一个大的混合"节点" / Multipart ）
		MimeMultipart mm = new MimeMultipart();
		mm.addBodyPart(text);
		mm.addBodyPart(attachment); // 如果有多个附件，可以创建多个多次添加
		mm.setSubType("related");  // 混合关系

		// 11. 设置整个邮件的关系（将最终的混合"节点"作为邮件的内容添加到邮件对象）
		msg.setContent(mm);
		//设置邮件的发送时间,默认立即发送
		msg.setSentDate(new Date());

		return msg;
	}




}
