package com.example.tdl.util;

import java.net.URLDecoder;
import java.text.DecimalFormat;

public class MapUtils {

        private static double EARTH_RADIUS = 6371.393;
        private static double rad(double d)
        {
            return d * Math.PI / 180.0;
        }

        /**
         * 计算两个经纬度之间的距离
         * @param lat1
         * @param lng1
         * @param lat2
         * @param lng2
         * @return
         */
        public static double getDistance(double lat1, double lng1, double lat2, double lng2)
        {
            double radLat1 = rad(lat1);
            double radLat2 = rad(lat2);
            double a = radLat1 - radLat2;
            double b = rad(lng1) - rad(lng2);
            double s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a/2),2) +
                    Math.cos(radLat1)*Math.cos(radLat2)*Math.pow(Math.sin(b/2),2)));
            s = s * EARTH_RADIUS;
            s = Math.round(s * 1000);
//            System.out.println("s:"+s);
            return s;
        }

        public static  double  getTransSpeed(double lat1, double lng1, double lat2, double lng2,Long  time){
            if(time ==0){
                return 0d;
            }
            double s = getDistance( lat1,  lng1,  lat2,  lng2);
            double speed =  (double) s/time;
            System.out.println("lng:" + lng1  +" ----lat:" +lat1 +" ----speed:" + speed  +" ---time :" +time +" -----distance:"+s);
            if(s< 10000){
                //计算速度
                if(speed>60){
                    return  0;
                }
                return  s/time;
            }else{
                return s/time;
            }
        }


        //计算速度
        public static  double getSpeed(double lat1, double lng1, double lat2, double lng2,Long  time,Float sppeed){
            if(time ==0){
                return 0d;
            }
            double s = getDistance( lat1,  lng1,  lat2,  lng2);
            double speed =  (double) s/time;
          System.out.println("lng:" + lng1  +" ----lat:" +lat1 +" ----speed:" + speed  +" ---time :" +time +" -----distance:"+s);
            if(s <1000 || s> 10000){
                //计算速度
                if(speed>60 || speed <sppeed){
                    return  0;
                }
                return  s/time;
            }else{
                if(speed>60 || speed <sppeed){
                    return  0;
                }
                return s/time;
            }

        }

        public static void main(String[] args) {
            DecimalFormat df = new DecimalFormat("0.0000");
           double  d =  (double)37/44300;
           System.out.println("d:" + df.format(d));
            double p=1013.25* Math.pow((1 - Double.valueOf(df.format(d))),5.256);
             System.out.println(URLDecoder.decode("%5C"));


        }

}
