package com.example.tdl.web;


import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.domain.vo.UpdateCircuitTransferArrivalTimeVo;
import com.example.tdl.domain.vo.UpdateCircuitTransferStartTimeVo;
import com.example.tdl.service.CircuitTransferService;
import com.example.tdl.service.RoleService;
import com.example.tdl.service.redis.TokenRedisService;
import com.google.gson.Gson;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


@RestController
@RequestMapping("/circuitTransfer")
public class CircuitTransferController {

    private Logger logger = LoggerFactory.getLogger(CircuitTransferController.class);

    CommFeedback fb=new CommFeedback();

    Gson gson=new Gson();

    @Autowired
    private CircuitTransferService circuitTransferService;

    @Autowired
    private TokenRedisService tokenRedisService;

    @Autowired
    private I18nController  i18n;


    //修改线路途径地到达时间
    @ApiOperation(value = "修改线路途径地到达时间",notes = "修改线路途径地到达时间，修改所需要传的参数：" +
            "   transportationNo:线路编号," +
            "   sequence:途径序号," +
            "   arrivalTime:修改的到达时间。")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
    })
    @RequestMapping(value="/updateArrivalTime",method = RequestMethod.POST)
    public Object updateArrivalTime(@RequestBody UpdateCircuitTransferArrivalTimeVo updateCircuitTransferArrivalTimeVo){
        if (StringUtils.isEmpty(updateCircuitTransferArrivalTimeVo.getTransportationNo())){
            fb.setCode(0);
            fb.setMessage("需要修改的线路编号不能为空");
            return gson.toJson(fb);
        }
        if (updateCircuitTransferArrivalTimeVo.getSequence()==null){
            fb.setCode(0);
            fb.setMessage("需要修改的途径地序号不能为空");
            return gson.toJson(fb);
        }
        if (updateCircuitTransferArrivalTimeVo.getArrivalTime()==null){
            fb.setCode(0);
            fb.setMessage("修改后的到达时间不能为空");
            return gson.toJson(fb);
        }
        int a = circuitTransferService.updateArrivalTime(updateCircuitTransferArrivalTimeVo);
        if (a>=0){
            fb.setCode(1);
            fb.setMessage("修改途径地到达时间成功");
        }else{
            fb.setCode(0);
            fb.setMessage("修改途径地到达时间失败");
        }
        return gson.toJson(fb);
    }

    //修改线路途径地到达时间
    @ApiOperation(value = "修改线路途径地到达时间",notes = "修改线路途径地到达时间，修改所需要传的参数：" +
            "   transportationNo:线路编号," +
            "   sequence:途径序号," +
            "   arrivalTime:修改的到达时间。")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
    })
    @RequestMapping(value="/updateStartTime",method = RequestMethod.POST)
    public Object updateStartTime(@RequestBody UpdateCircuitTransferStartTimeVo updateCircuitTransferStartTimeVo){
        if (StringUtils.isEmpty(updateCircuitTransferStartTimeVo.getTransportationNo())){
            fb.setCode(0);
            fb.setMessage("需要修改的线路编号不能为空");
            return gson.toJson(fb);
        }
        if (updateCircuitTransferStartTimeVo.getSequence()==null){
            fb.setCode(0);
            fb.setMessage("需要修改的途径地序号不能为空");
            return gson.toJson(fb);
        }
        if (updateCircuitTransferStartTimeVo.getStartTime()==null){
            fb.setCode(0);
            fb.setMessage("修改后的出发时间不能为空");
            return gson.toJson(fb);
        }
        int a = circuitTransferService.updateStartTime(updateCircuitTransferStartTimeVo);
        if (a>=0){
            fb.setCode(1);
            fb.setMessage("修改途径地出发时间成功");
        }else{
            fb.setCode(0);
            fb.setMessage("修改途径地出发时间失败");
        }
        return gson.toJson(fb);
    }

}
