package com.example.tdl.web;


import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.domain.vo.UserRedisVo;
import com.example.tdl.service.RoleHasPermissionService;

import com.example.tdl.service.redis.TokenRedisService;
import com.google.gson.Gson;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping("/roleHasPermission")
public class RoleHasPermissionController {

    private Logger logger = LoggerFactory.getLogger(RoleHasPermissionController.class);

    CommFeedback fb=new CommFeedback();

    Gson gson=new Gson();

    @Autowired
    private RoleHasPermissionService roleHasPermissionService=new RoleHasPermissionService();

    @Autowired
    private TokenRedisService tokenRedisService;


    //查询本公司的用户
    @ApiOperation(value = "查询所有权限信息",notes = "查询所有权限信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
    })
    @RequestMapping(value="/getAll",method = RequestMethod.GET)
    public Object getAll(HttpServletRequest request){
        String token = request.getHeader("Account_token");
        String datum = tokenRedisService.get("TOKEN_" +token);
        UserRedisVo user =  gson.fromJson(datum,UserRedisVo.class);
        if(datum == null){
            fb.setCode(0);
            fb.setMessage("您没有登录，请先登录");
            return gson.toJson(fb);
        }else{
            return roleHasPermissionService.getByRoleName(user.getRoleName(),user.getCompanyNo());
        }
    }



}
