package com.example.tdl.web;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.domain.vo.ResultSideVo;
import com.example.tdl.domain.vo.UserRedisVo;
import com.example.tdl.service.RoleService;
import com.example.tdl.service.SideService;
import com.example.tdl.service.redis.TokenRedisService;
import com.google.gson.Gson;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.apache.shiro.SecurityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

@RestController
@RequestMapping("/side")
public class SideController {
    private Logger logger = LoggerFactory.getLogger(this.getClass());

    Gson gson=new Gson();

    CommFeedback fb=new CommFeedback();

    @Autowired
    private SideService sideService;

    @Autowired
    private RoleService roleService;

    @Autowired
    private TokenRedisService tokenRedisService;

    @Autowired
    private I18nController  i18n;

    @ApiImplicitParams({
            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
    })
    @RequestMapping(value = "selectAllTitle",method = RequestMethod.GET)
    public Object selectAllTitle(HttpServletRequest request){
        String token = request.getHeader("Account_token");
        String datum = tokenRedisService.get("TOKEN_" +token);
        UserRedisVo user =  gson.fromJson(datum,UserRedisVo.class);
//        //获取用户角色编号
//        String roleName = roleService.getRoleNameByUserName(user.getUserName());
        //获取该用户所有的权限及对应的界面
        List<ResultSideVo> sliderTitleVoList=sideService.selectAllTitle(user.getRoleName(),user.getCompanyNo());
        Set<String> l=new HashSet<>();
        for (int i=0;i<sliderTitleVoList.size();i++){
            l.add(sliderTitleVoList.get(i).getpName());
            l.add(sliderTitleVoList.get(i).getSideTitle());
        }
        return l;
    }

    @ApiImplicitParams({
            @ApiImplicitParam(paramType="header", name = "Account_token", value = "token", required = true, dataType = "String"),
    })
    @RequestMapping(value = "selectBySliderTitle",method = RequestMethod.POST)
    public Object selectBySliderTitle(@RequestBody String name,HttpServletRequest request){
        String token = request.getHeader("Account_token");
        String datum = tokenRedisService.get("TOKEN_" +token);
        UserRedisVo user =  gson.fromJson(datum,UserRedisVo.class);
        JSONObject jsonObject= JSON.parseObject(name);
        name=(String)jsonObject.get("name");
        if (name.equals("")||name==null){
            fb.setCode(0);
            fb.setMessage("查询的侧边栏名不能为空");
            return gson.toJson(fb);
        }
        //获取该用户所有的权限及对应的界面
        List<ResultSideVo> sliderTitleVoList=sideService.selectBySideTitle(user.getRoleName(),user.getCompanyNo(),name);
        Set<String> l=new HashSet<>();
        for (int i=0;i<sliderTitleVoList.size();i++){
            l.add(sliderTitleVoList.get(i).getPermissionName());
        }
        return l;
    }

}
