package com.example.tdl.web.exception;


import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.web.I18nController;
import com.google.gson.Gson;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.BadSqlGrammarException;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.sql.SQLException;

@ControllerAdvice
@ResponseBody
public class GlobalExceptionHandler {

    private Logger logger = LoggerFactory.getLogger(GlobalExceptionHandler.class);

    private CommFeedback fb = new CommFeedback();

    private Gson gson = new Gson();

    @Autowired
    private I18nController i18n;

    @ExceptionHandler(value=Exception.class)
    public String allExceptionHandler(HttpServletRequest request, Exception e) throws Exception {
        e.printStackTrace();
        if (e instanceof NullPointerException) {
            logger.error("代码00：" + e.getMessage(), e);
            fb.setCode(0);
            fb.setMessage(i18n.getMessage(request,"null"));
        } else if (e instanceof IllegalArgumentException) {
            logger.error("代码01：" + e.getMessage(), e);
            fb.setCode(0);
            fb.setMessage(i18n.getMessage(request,"illegal"));
        } else if (e instanceof SQLException) {
            logger.error("代码02：" + e.getMessage(), e);
            fb.setCode(0);
            fb.setMessage(i18n.getMessage(request,"sql"));
        } else if(e instanceof BadSqlGrammarException) {
            logger.error("代码03：" + e.getMessage(), e);
            fb.setCode(0);
            fb.setMessage(i18n.getMessage(request,"badSql"));
        }else{
            logger.error("代码99：" + e.getMessage(), e);
            fb.setCode(0);
            fb.setMessage(i18n.getMessage(request,"error"));
        }

        return gson.toJson(fb);
    }

}
